<?php

class ControllerExtensionPaymentVerifoneHosted extends Controller
{

    /**
     * ControllerExtensionPaymentVerifoneHosted constructor.
     * @param $registry
     */
    public function __construct($registry)
    {
        parent::__construct($registry);
        $this->load->language('extension/payment/verifone_hosted');
        $this->load->model('extension/payment/verifone_hosted');
        $this->load->model('checkout/order');
    }

    /**
     * @return mixed
     */
    public function index()
    {

        $data['button_confirm'] = $this->language->get('button_confirm');
        $data['action'] = $this->url->link('extension/payment/verifone_hosted/checkout');
        if (!empty($this->session->data['order_id'])) {
            $data['order_id'] = $this->session->data['order_id'];
            $data['payment_type'] = ($this->config->get('payment_verifone_hosted_cart_payment_type'));

            return $this->load->view('extension/payment/verifone_hosted', $data);
        }
    }

    /**
     *checkout & place an order
     */
    public function checkout()
    {
        if (empty($this->request->post['order_id'])) {
            exit('Invalid request');
        }

        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(
            $this->model_extension_payment_verifone_hosted->create($this->request->post['order_id'])
        );
    }

    /**
     * @throws \Exception
     */
    public function callback()
    {
        $params = $_GET;

        if (!isset($params['checkout_id'])) {
            $this->response->redirect($this->url->link('checkout/failure', '', true));
            throw new Exception('There was an error in the application');
        }
        if ($this->model_extension_payment_verifone_hosted->updateOrder($params))
            $this->response->redirect($this->url->link('checkout/success', '', true));

        $this->response->redirect($this->url->link('checkout/failure', '', true));
    }


}
