<?php

namespace VerifoneEcomApi\ApiWrapper;

/**
 * Class Settings
 * @package VerifoneEcomApi\ApiWrapper
 */
class Settings
{
    const MISSING_ORDER = 'missing_order';
    const PAYMENT_TYPE_HPP = 'hpp';
    const PAYMENT_TYPE_IFRAME = 'iframe';
    const HASHED_KEY_LENGTH = 36;
    private $test;
    private $region;
    private $theme_id;
    private $api_user;
    private $api_key;
    private $card_enabled;
    private $_3ds_enable;
    private $payment_contract_id;
    private $_3ds_contract_id;
    private $_is_fraud_check_enabled;
    private $_fraud_check_contract_id;
    private $entity_id;
    private $curl_verify_ssl;
    private $overlay_on_place_order;
    private $complete_order_on_payment;
    private $paymentType;
    private $isApplePayEnabled;
    private $applePayScaComplianceLevel;
    private $applePayContractId;
    private $isGooglePayEnabled;
    private $googlePayScaComplianceLevel;
    private $googlePayContractId;
    private $isPayPalEnabled;
    private $payPalContractId;
    private $isKlarnaEnabled;
    private $isVippsEnabled;
    private $vippsScaComplianceLevel;
    private $vippsContractId;
    private $vipps3DSContractId;
    private $isMobilePayEnabled;
    private $mobilePayScaComplianceLevel;
    private $mobilePayContractId;
    private $mobilePay3DSContractId;
    private $isSwishEnabled;
    private $isGpp2Enabled;
    private $gpp2PayContractId;
    private $isAbsEnabled;
    private $absInstallments;
    private string $transactionType;
    private $giftCardEnabled;
    private $giftCardContractId;
    private $plccEnabled;
    private $plccContractId;

    /**
     * @return mixed
     */
    public function getPlccEnabled()
    {
        return $this->plccEnabled;
    }

    /**
     * @param mixed $plccEnabled
     * @return Settings
     */
    public function setPlccEnabled($plccEnabled)
    {
        $this->plccEnabled = $plccEnabled;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getPlccContractId()
    {
        return $this->plccContractId;
    }

    /**
     * @param mixed $plccContractId
     * @return Settings
     */
    public function setPlccContractId($plccContractId)
    {
        $this->plccContractId = $plccContractId;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getGiftCardEnabled()
    {
        return $this->giftCardEnabled;
    }

    /**
     * @param mixed $giftCardEnabled
     * @return Settings
     */
    public function setGiftCardEnabled($giftCardEnabled)
    {
        $this->giftCardEnabled = $giftCardEnabled;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getGiftCardContractId()
    {
        return $this->giftCardContractId;
    }

    /**
     * @param mixed $giftCardContractId
     * @return Settings
     */
    public function setGiftCardContractId($giftCardContractId)
    {
        $this->giftCardContractId = $giftCardContractId;
        return $this;
    }

    public function getCapture()
    {
        return $this->transactionType === 'SALE';
    }

    /**
     * @return string
     */
    public function getTransactionType()
    {
        return $this->transactionType === 'PRE_AUTH' ? 'PRE_AUTH' : 'FINAL_AUTH';
    }

    /**
     * @param mixed $transactionType
     * @return Settings
     */
    public function setTransactionType($transactionType)
    {
        $this->transactionType = $transactionType;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getIsSwishEnabled()
    {
        return $this->isSwishEnabled;
    }

    /**
     * @param mixed $isSwishEnabled
     * @return Settings
     */
    public function setIsSwishEnabled($isSwishEnabled)
    {
        $this->isSwishEnabled = $isSwishEnabled;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getIsGpp2Enabled()
    {
        return $this->isGpp2Enabled;
    }

    /**
     * @param mixed $isGpp2Enabled
     * @return Settings
     */
    public function setIsGpp2Enabled($isGpp2Enabled)
    {
        $this->isGpp2Enabled = $isGpp2Enabled;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getGpp2PayContractId()
    {
        return $this->gpp2PayContractId;
    }

    /**
     * @param mixed $gpp2PayContractId
     * @return Settings
     */
    public function setGpp2PayContractId($gpp2PayContractId)
    {
        $this->gpp2PayContractId = $gpp2PayContractId;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getIsAbsEnabled()
    {
        return $this->isAbsEnabled;
    }

    /**
     * @param mixed $isAbsEnabled
     * @return Settings
     */
    public function setIsAbsEnabled($isAbsEnabled)
    {
        $this->isAbsEnabled = $isAbsEnabled;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getAbsInstallments($total)
    {
        $installments = json_decode($this->absInstallments, true);
        foreach ($installments['nr'] as $k => $number) {
            //ILS have 2 decimals, so we need to multiply with 100
            $min = $installments['min'][$k] * 100;
            $max = $installments['max'][$k] * 100;
            if ($min < $total && $max >= $total) {
                return $number;
            }
        }
        return 0;
    }

    /**
     * @param mixed $absInstallments
     * @return Settings
     */
    public function setAbsInstallments($absInstallments)
    {
        $this->absInstallments = json_encode($absInstallments);
        return $this;
    }


    /**
     * @return mixed
     */
    public function getIsMobilePayEnabled()
    {
        return $this->isMobilePayEnabled;
    }

    /**
     * @param mixed $isMobilePayEnabled
     * @return Settings
     */
    public function setIsMobilePayEnabled($isMobilePayEnabled)
    {
        $this->isMobilePayEnabled = $isMobilePayEnabled;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getMobilePayScaComplianceLevel()
    {
        return $this->mobilePayScaComplianceLevel;
    }

    /**
     * @param mixed $mobilePayScaComplianceLevel
     * @return Settings
     */
    public function setMobilePayScaComplianceLevel($mobilePayScaComplianceLevel)
    {
        $this->mobilePayScaComplianceLevel = $mobilePayScaComplianceLevel;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getMobilePayContractId()
    {
        return $this->mobilePayContractId;
    }

    /**
     * @param mixed $mobilePayContractId
     * @return Settings
     */
    public function setMobilePayContractId($mobilePayContractId)
    {
        $this->mobilePayContractId = $mobilePayContractId;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getMobilePay3DSContractId()
    {
        return $this->mobilePay3DSContractId;
    }

    /**
     * @param mixed $mobilePay3DSContractId
     * @return Settings
     */
    public function setMobilePay3DSContractId($mobilePay3DSContractId)
    {
        $this->mobilePay3DSContractId = $mobilePay3DSContractId;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getIsKlarnaEnabled()
    {
        return $this->isKlarnaEnabled;
    }

    /**
     * @return mixed
     */
    public function getIsVippsEnabled()
    {
        return $this->isVippsEnabled;
    }

    /**
     * @param mixed $isVippsEnabled
     * @return Settings
     */
    public function setIsVippsEnabled($isVippsEnabled)
    {
        $this->isVippsEnabled = $isVippsEnabled;
        return $this;
    }

    /**
     * @param $isKlarnaEnabled
     * @return $this
     */
    public function setKlarnaEnabled($isKlarnaEnabled)
    {
        $this->isKlarnaEnabled = $isKlarnaEnabled;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getVippsScaComplianceLevel()
    {
        return $this->vippsScaComplianceLevel;
    }

    /**
     * @param mixed $vippsScaComplianceLevel
     * @return Settings
     */
    public function setVippsScaComplianceLevel($vippsScaComplianceLevel)
    {
        $this->vippsScaComplianceLevel = $vippsScaComplianceLevel;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getVippsContractId()
    {
        return $this->vippsContractId;
    }

    /**
     * @param mixed $vippsContractId
     * @return Settings
     */
    public function setVippsContractId($vippsContractId)
    {
        $this->vippsContractId = $vippsContractId;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getVipps3DSContractId()
    {
        return $this->vipps3DSContractId;
    }

    /**
     * @param mixed $vipps3DSContractId
     * @return Settings
     */
    public function setVipps3DSContractId($vipps3DSContractId)
    {
        $this->vipps3DSContractId = $vipps3DSContractId;
        return $this;
    }


    /**
     * @return mixed
     */
    public function getOverlayOnPlaceOrder()
    {
        return $this->overlay_on_place_order;
    }

    /**
     * @param mixed $overlay_on_place_order
     *
     * @return $this
     */
    public function setOverlayOnPlaceOrder($overlay_on_place_order)
    {
        $this->overlay_on_place_order = $overlay_on_place_order;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getCurlVerifySsl()
    {
        return $this->curl_verify_ssl;
    }

    /**
     * @param mixed $curl_verify_ssl
     *
     * @return $this
     */
    public function setCurlVerifySsl($curl_verify_ssl)
    {
        $this->curl_verify_ssl = $curl_verify_ssl;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getEntityId()
    {
        return $this->entity_id;
    }

    /**
     * @param mixed $entity_id
     *
     * @return $this
     */
    public function setEntityId($entity_id)
    {
        $this->entity_id = $entity_id;

        return $this;
    }

    /**
     * @return mixed
     */
    public function get3dsContractId()
    {
        return $this->_3ds_contract_id;
    }

    /**
     * @param $contractId
     *
     * @return $this
     */
    public function set3dsContractId($contractId)
    {
        $this->_3ds_contract_id = $contractId;

        return $this;
    }

    /**
     * @return mixed
     */
    public function isTest()
    {
        return $this->test;
    }

    /**
     * @return mixed
     */
    public function getRegion()
    {
        return $this->region;
    }

    /**
     * @return mixed
     */
    public function getApiUserId()
    {
        return $this->api_user;
    }

    /**
     * @return mixed
     */
    public function getApiKey()
    {
        return $this->api_key;
    }

    /**
     * @return mixed
     */
    public function isCardEnabled()
    {
        return $this->card_enabled;
    }


    /**
     * @return mixed
     */
    public function is3dsEnabled()
    {
        return $this->_3ds_enable;
    }

    /**
     * @return mixed
     */
    public function getPaymentContractId()
    {
        return $this->payment_contract_id;
    }

    /**
     * @return mixed
     */
    public function getCompleteOrderOnPayment()
    {
        return $this->complete_order_on_payment;
    }

    /**
     * @param mixed $test
     *
     * @return $this
     */
    public function setTest($test)
    {
        $this->test = $test;

        return $this;
    }

    /**
     * @param mixed $region
     *
     * @return $this
     */
    public function setRegion($region)
    {
        $this->region = $region;

        return $this;
    }

    /**
     * @param mixed $api_user
     *
     * @return $this
     */
    public function setApiUserId($api_user)
    {
        $this->api_user = $api_user;

        return $this;
    }

    /**
     * @param mixed $api_key
     *
     * @return $this
     */
    public function setApiKey($api_key)
    {
        $this->api_key = $api_key;

        return $this;
    }


    /**
     * @param bool $card_enabled
     *
     * @return $this
     */
    public function setCardEnable($card_enabled)
    {
        $this->card_enabled = $card_enabled;

        return $this;
    }

    /**
     * @param $_3ds
     *
     * @return $this
     */
    public function set3dsEnable($_3ds)
    {
        $this->_3ds_enable = $_3ds;

        return $this;
    }

    /**
     * @param mixed $payment_contract_id
     *
     * @return $this
     */
    public function setPaymentContractId($payment_contract_id)
    {
        $this->payment_contract_id = $payment_contract_id;

        return $this;
    }

    /**
     * @param $complete_order_on_payment
     *
     * @return $this
     */
    public function setCompleteOrderOnPayment($complete_order_on_payment)
    {
        $this->complete_order_on_payment = $complete_order_on_payment;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getPaymentType()
    {
        return strtoupper($this->paymentType);
    }

    /**
     * @param mixed $this
     */
    public function setPaymentType($paymentType)
    {
        $this->paymentType = $paymentType;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getThemeId()
    {
        return $this->theme_id;
    }

    /**
     * @param mixed $theme_id
     */
    public function setThemeId($theme_id)
    {
        $this->theme_id = $theme_id;
        return $this;
    }

    /**
     * @return mixed
     */
    public function isFraudCheckEnabled()
    {
        return $this->_is_fraud_check_enabled;
    }

    /**
     * @param mixed $fraud_check_enabled
     */
    public function setFraudCheckEnabled($fraud_check_enabled)
    {
        $this->_is_fraud_check_enabled = $fraud_check_enabled;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getFraudCheckContractId()
    {
        return $this->_fraud_check_contract_id;
    }

    /**
     * @param mixed $fraud_check_contract_id
     */
    public function setFraudCheckContractId($fraud_check_contract_id)
    {
        $this->_fraud_check_contract_id = $fraud_check_contract_id;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getApplePayContractId()
    {
        return $this->applePayContractId;
    }

    /**
     * @param mixed $applePayContractId
     *
     * @return Settings
     */
    public function setApplePayContractId($applePayContractId)
    {
        $this->applePayContractId = $applePayContractId;

        return $this;
    }

    /**
     * @return mixed
     */
    public function isApplePayEnabled()
    {
        return $this->isApplePayEnabled && strlen($this->getApplePayContractId()) === self::HASHED_KEY_LENGTH;
    }

    /**
     * @param mixed $isApplePayEnabled
     *
     * @return Settings
     */
    public function setIsApplePayEnabled($isApplePayEnabled)
    {
        $this->isApplePayEnabled = $isApplePayEnabled;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getApplePayScaComplianceLevel()
    {
        return $this->applePayScaComplianceLevel;
    }

    /**
     * @param mixed $applePayScaComplianceLevel
     *
     * @return Settings
     */
    public function setApplePayScaComplianceLevel($applePayScaComplianceLevel)
    {
        $this->applePayScaComplianceLevel = $applePayScaComplianceLevel;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getGooglePayContractId()
    {
        return $this->googlePayContractId;
    }

    /**
     * @param mixed $googlePayContractId
     *
     * @return Settings
     */
    public function setGooglePayContractId($googlePayContractId)
    {
        $this->googlePayContractId = $googlePayContractId;

        return $this;
    }

    /**
     * @return mixed
     */
    public function isGooglePayEnabled()
    {
        return $this->isGooglePayEnabled && strlen($this->getGooglePayContractId()) === self::HASHED_KEY_LENGTH;
    }

    /**
     * @param mixed $isGooglePayEnabled
     *
     * @return Settings
     */
    public function setIsGooglePayEnabled($isGooglePayEnabled)
    {
        $this->isGooglePayEnabled = $isGooglePayEnabled;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getGooglePayScaComplianceLevel()
    {
        return $this->googlePayScaComplianceLevel;
    }

    /**
     * @param mixed $googlePayScaComplianceLevel
     *
     * @return Settings
     */
    public function setGooglePayScaComplianceLevel($googlePayScaComplianceLevel)
    {
        $this->googlePayScaComplianceLevel = $googlePayScaComplianceLevel;

        return $this;
    }

    /**
     * @return bool
     */
    public function isPayPalEnabled()
    {
        return $this->isPayPalEnabled && strlen($this->getPayPalContractId()) === self::HASHED_KEY_LENGTH;
    }

    /**
     * @param mixed $isPayPalEnabled
     * @return Settings
     */
    public function setIsPayPalEnabled($isPayPalEnabled)
    {
        $this->isPayPalEnabled = $isPayPalEnabled;

        return $this;
    }

    /**
     * @return string
     */
    public function getPayPalContractId()
    {
        return $this->payPalContractId;
    }

    /**
     * @param string $payPalContractId
     * @return Settings
     */
    public function setPayPalContractId($payPalContractId)
    {
        $this->payPalContractId = $payPalContractId;

        return $this;
    }
}